import type { CacheNode } from '../../shared/lib/app-router-context';
import type { FlightRouterState, FlightData } from '../../server/app-render';
declare type PushRef = {
    /**
     * If the app-router should push a new history entry in useEffect()
     */
    pendingPush: boolean;
    /**
     * Multi-page navigation through location.href.
     */
    mpaNavigation: boolean;
};
export declare type FocusRef = {
    /**
     * If focus should be set in the layout-router's useEffect()
     */
    focus: boolean;
};
declare type AppRouterState = {
    tree: FlightRouterState;
    cache: CacheNode;
    pushRef: PushRef;
    focusRef: FocusRef;
    canonicalUrl: string;
};
export declare const ACTION_RELOAD = "reload";
export declare const ACTION_NAVIGATE = "navigate";
export declare const ACTION_RESTORE = "restore";
export declare const ACTION_SERVER_PATCH = "server-patch";
export declare function reducer(state: AppRouterState, action: {
    type: typeof ACTION_RELOAD;
    url: URL;
    cache: CacheNode;
    mutable: {
        previousTree?: FlightRouterState;
        patchedTree?: FlightRouterState;
    };
} | {
    type: typeof ACTION_NAVIGATE;
    url: URL;
    cacheType: 'soft' | 'hard';
    navigateType: 'push' | 'replace';
    cache: CacheNode;
    mutable: {
        previousTree?: FlightRouterState;
        patchedTree?: FlightRouterState;
    };
} | {
    type: typeof ACTION_RESTORE;
    url: URL;
    tree: FlightRouterState;
} | {
    type: typeof ACTION_SERVER_PATCH;
    flightData: FlightData;
    previousTree: FlightRouterState;
    cache: CacheNode;
}): AppRouterState;
export {};
